
```@meta
CurrentModule = BiochemNetABC
```

# BiochemNetABC.jl

*A Julia package for efficient simulation, statistical inference and verification of Continuous Time Markov Chains 
modeled by Biochemical networks, also called Chemical Reaction Networks (CRN), with Approximate Bayesian Computation methods (ABC).*

## Package features

* A core of simulation for Continuous-Time Markov Chains (CTMC) defined by Biochemical networks/CRN,
* A simple interface for Biochemical Networks/Stochastic Petri Nets,
* Synchronized simulation with Linear Hybrid Automata,
* Approximate Bayesian Computation, a likelihood-free inference method,
* Automaton-ABC: a statistical method for verification of parametric CTMCs.

